export type MessageType = 'user' | 'system';

export interface Message {
    id: string;
    content: string;
    type: MessageType;
    timestamp: Date;
}

export interface ChatConfig {
    model: string;
    temperature: number;
    maxTokens: number;
}

export interface ChatResponse {
    message: Message;
    usage?: {
        promptTokens: number;
        completionTokens: number;
        totalTokens: number;
    };
} 